#!/usr/bin/env python
'''
** This file consitutes part of NCSSWiki
 * Version 2.0 (beta release 2)
 * (c) 2006 Chris Neugebauer -- http://noogz.net -- chris@noogz.net
 * and contributors from the 2006 National Computer Science School
 *
 * NCSSWiki is the legal property of Christopher Neugebauer and contributors,
 * and is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) any later 
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * or visit http://www.gnu.org/licenses/gpl.html
 *'''
import sys
import wiki_getdb
import cgi
import cgitb
import config
import re
from makepage import makepage	#Template parser

conf = config.py		#Get configuration directives
cgitb.enable()

fields = cgi.FieldStorage()

#Can only edit if an article name is specified
if not fields.has_key("article"):
	print "Location: index.cgi\n\n"

article		 = fields["article"].value.replace("<","&lt;").replace(">","&gt;")

#Get text to edit
article_text	= wiki_getdb.get_wiki_code(article)

#Dodgy HTML workarounds
if article_text <> 0:
	article_text	=   re.sub("&","&amp;",article_text)

if article_text == 0:
		article_text = ""

sys.stderr = sys.stdout

pagename = "Editing: " + article	#Page name for template parser

output = '''
<form action="commit.cgi" method="post"><br>
	<input type="hidden" name="article" value="'''+article+'''"><br>
	<textarea rows="25" cols="80" name="articlecontents">'''+article_text+'''</textarea><br>
	<input type="submit" value="Submit Changes">
	<input type="reset" value="Reset form">
</form>
<hr>
<h3>Formatting Reference</h3>
<p>\'\'<em>italic text</em>\'\' 
\'\'\'<strong>bold text</strong>\'\'\' 
\'\'\'\'<u>underline</u>\'\'\'\'<br /> 
=1st Level Heading=
==2nd Level Heading==
===3rd Level Heading===
====4th Level Heading====
=====5th Level Heading===== <br />
[[Link to article of this name]]
[http://link-to-external=-site] <br />
* Bullet List <br />
&lt;nowiki&gt;Do not parse as WikiCode
(useful for adding Python examples)&lt/nowiki&gt;<br />
<hr />
<h4>Delete article</h4>
<form action="delete.cgi" method="post">
	<input type="hidden" value="'''+article+'''" name="article">
	<input name="password" type="password">
</form>
</body>
</html>
'''

makepage(pagename, output)
