## wiki_getdb.py - Routines for returning stuff in the database
'''
** This file consitutes part of NCSSWiki
 * Version 2.0 (beta release 2)
 * (c) 2006 Chris Neugebauer -- http://noogz.net -- chris@noogz.net
 * and contributors from the 2006 National Computer Science School
 *
 * NCSSWiki is the legal property of Christopher Neugebauer and contributors,
 * and is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) any later 
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * or visit http://www.gnu.org/licenses/gpl.html
 *'''
import config
conf = config.py

def get_wiki_code(key):
	## Returns the unparsed wiki code from database, matched by key.

   global conf
   import bsddb

   db_unparsed  =   bsddb.btopen(conf["unparsed"])

   if db_unparsed.has_key(key):
	   temp		 =   db_unparsed[key]
	   db_unparsed.close()
	   return temp
   else:
	   db_unparsed.close()
	   return 0

		

def get_html(key):
	## Returns the parsed html code from the database, matched by key.

	global conf
	import bsddb
	import wiki_parser

	#db_parsed   =   bsddb.btopen(conf["parsed"])
 	db_unparsed  =   bsddb.btopen(conf["unparsed"])

	if db_unparsed.has_key(key):
		temp		=   db_unparsed[key]
		db_unparsed.close()
		return wiki_parser.parse_wiki(temp)
	else:
		db_unparsed.close()
		return 0

def exists(key):
	## Checks to see whether article "key" exists

	global conf
	import bsddb

	db_unparsed   =   bsddb.btopen(conf["unparsed"])

	if db_unparsed.has_key(key):
			temp = True
	else:
			temp = False

	db_unparsed.close()

	return temp

def get_timestamp(key):
	## Checks for timestamp on article "key" exists
	## and if so, return it.

	global conf
	import bsddb

	db_times	=   bsddb.btopen(conf["timestamps"])

	if db_times.has_key(key):
			temp = db_times[key]
	else:
			temp = ""

	db_times.close()

	return temp
	
def get_articles():
	## Returns names of all articles in a list

	global conf
	import bsddb

	db_unparsed   =   bsddb.btopen(conf["unparsed"])
	temp		=   db_unparsed.keys()
	db_unparsed.close()

	return temp
