## putdb.py
## routines for adding parsed and unparsed pages to the wiki.
'''
** This file consitutes part of NCSSWiki
 * Version 2.0 (beta release 2)
 * (c) 2006 Chris Neugebauer -- http://noogz.net -- chris@noogz.net
 * and contributors from the 2006 National Computer Science School
 *
 * NCSSWiki is the legal property of Christopher Neugebauer and contributors,
 * and is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) any later 
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * or visit http://www.gnu.org/licenses/gpl.html
 *'''
import bsddb
import config
conf = config.py

def putdb(key,wiki_code):
    ## putdb will add unparsed wiki code to unparsed.db
    ## and parsed html to parsed.db.
    ## Key = Article Name, wiki_code = unparsed wiki code
    global conf

    import wiki_parser  ## Imports Chris' Wiki Code implementation
    import datetime
    
    db_unparsed =   bsddb.btopen(conf["unparsed"])
    #db_parsed   =   bsddb.btopen(conf["parsed"])
    db_times    =   bsddb.btopen(conf["timestamps"])

    #html = wiki_parser.parse_wiki(wiki_code)
    timestamp = str(datetime.datetime.today()).split(".")[0]

    db_unparsed[key]   =   wiki_code
    #db_parsed[key]     =   html
    db_times[key]      =   timestamp

    db_unparsed.close()
    #db_parsed.close()
    db_times.close()

def deldb(key,password):
    ## If password is correct, then delete specified article
    global conf

    if password==conf["deletepw"]:
        import bsddb
	
	#This is re-implemented for the fun of it
	#Go through each database and delete the key	
	#for i in ["unparsed","parsed","timestamps"]:
	for i in ["unparsed","timestamps"]:	
		db = bsddb.btopen(conf[i])
		del db[key]
		db.close()

        return True
    else:
        return False


    
